#include <iostream>
#include <unistd.h>

#include <sys/types.h>
#include <sys/wait.h>

using namespace std;

int main(int argc, char * argv[]) {

  int n = atoi(argv[1]);

  srand (time(NULL));
  
  for(int i=0; i<n; i++) {
    int pid = fork();
    if(pid == 0) {
      // son process
      int s = rand()%4; 
      cout << "I'm process " << getpid()
	   << " awaiting " << s << " secs " << endl;
      sleep(s);
      exit(0);
    } else {
      // father, go on creating processes
      cout << "Created process pid=" << pid << endl; 
      continue;
    }
  }
  // now wait for process termination
  for(int i=0; i<n; i++) {
    int retcode, status;
    retcode = wait(&status);
    if(retcode == -1) {
      cerr << "Error in wait system call " << retcode << endl;
      return(retcode);
    } else {
      cout << "Pid " << retcode << " terminated ";
      if(WIFEXITED(status))
	cout << " exited with status " << WEXITSTATUS(status) << endl;
      if(WIFSIGNALED(status))
	cout << " signalled " << WTERMSIG(status) << endl;
      if(WIFSTOPPED(status))
	cout << " stopped " << WSTOPSIG(status) << endl; 
    }
  }
  return 0; 
}
			      
